<template>
  <div class="mapBox">
    <ol-map
      id="map"
      :loadTilesWhileAnimating="true"
      :loadTilesWhileInteracting="true"
      :cluster="true"
    >
      <ol-view
        ref="view"
        :center="centerMap()"
        :rotation="rotation"
        :zoom="zoom"
        :projection="projection"
      />

      <ol-tile-layer>
        <ol-source-osm />
      </ol-tile-layer>

      <ol-vector-layer>
        <ol-source-vector ref="vectorsource">
          <ol-feature>
            <ol-geom-point
              :coordinates="toXY(location.lon, location.lat)"
            ></ol-geom-point>
            <ol-style>
              <ol-style-icon
                :src="markerIcon"
                :scale="0.5"
                positioning="top-center"
              ></ol-style-icon>
            </ol-style>
          </ol-feature>
        </ol-source-vector>
      </ol-vector-layer>
    </ol-map>
  </div>
</template>

<script>
import { ref } from "vue";
import { fromLonLat } from "ol/proj";
import markerIcon from "@/assets/pin.png";

export default {
  props: {
    location: {
      type: Object,
    },
  },
  components: {},
  setup() {
    const center = fromLonLat([3.7099, 51.0602]);
    const zoom = ref(13.5);
    // const rotation = ref(0);
    const coordinate = ref([40, 40]);

    return {
      center,
      zoom,
      markerIcon,
      coordinate,
    };
  },
  data() {
    return {};
  },
  methods: {
    toXY(lon, lat) {
      return fromLonLat([lon, lat]);
    },
    centerMap() {
      return this.location?.lon + this.location?.lat != 0
        ? fromLonLat([this.location.lon, this.location.lat])
        : fromLonLat([3.7099, 51.0602]);
    },
  },
};
</script>

<style lang="scss" scoped>
.mapBox {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  width: 100%;
  height: 25rem;
  #map {
    flex-grow: 5;
    min-height: 10rem;
    height: 100%;
    width: 100%;
  }
}
</style>
